#include <gtk/gtk.h>

#include "helix.h"

/* names of the slots */
gchar * helix_names[HELIX_SLOT_LAST] =
{
   "Armlength (abs)",  /* HELIX_ARMLEN_ABS,  */
   "Armlenght (rel)",  /* HELIX_ARMLEN_REL,  */
   "Height (abs)",     /* HELIX_HEIGHT_ABS,  */
   "Height (rel)",     /* HELIX_HEIGHT_REL,  */
   "Size (abs)",       /* HELIX_SIZE_ABS,    */
   "Size (rel)",       /* HELIX_SIZE_REL,    */
   "Angle (abs)",      /* HELIX_ANGLE_ABS,   */
   "Angle (rel)",      /* HELIX_ANGLE_REL,   */
   "Roll (abs)",       /* HELIX_ROLL_ABS,    */
   "Roll (rel)",       /* HELIX_ROLL_REL,    */
   "Wave (abs)",       /* HELIX_WAVE_ABS,    */
   "Wave (rel)",       /* HELIX_WAVE_REL,    */
   "Wag (abs)",        /* HELIX_WAG_ABS,     */
   "Wag (rel)",        /* HELIX_WAG_REL,     */
   "L* (abs)",         /* HELIX_L_ABS,       */
   "L* (rel)",         /* HELIX_L_REL,       */
   "a* (abs)",         /* HELIX_A_ABS,       */
   "a* (rel)",         /* HELIX_A_REL,       */
   "b* (abs)",         /* HELIX_B_ABS,       */
   "b* (rel)",         /* HELIX_B_REL,       */
   "Opacity (abs)",    /* HELIX_OPACITY_ABS, */
   "Opacity (rel)",    /* HELIX_OPACITY_REL, */
   "X-Angle",          /* HELIX_VIEW_ROT_X   */
   "Y-Angle",          /* HELIX_VIEW_ROT_Y   */
   "Z-Angle",          /* HELIX_VIEW_ROT_Z   */
   "Rotation speed",   /* HELIX_ROTATION_REL */
   "n Vertices",       /* HELIX_N_VERTICES   */
};


GtkWidget *
helix_create_control_panel (HelixWindow *hwin)
{
  GtkWidget *win, *table;
  gint       row;

  win = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (win), "Helix controller");
  gtk_window_set_default_size (GTK_WINDOW (win), 500, -1);
  gtk_container_set_border_width (GTK_CONTAINER (win), 6);
  g_signal_connect (G_OBJECT (win), "delete_event",
                    G_CALLBACK (gtk_main_quit), NULL);

  table = gtk_table_new (HELIX_SLOT_LAST, 3, FALSE);
  gtk_container_add (GTK_CONTAINER (win), table);
  gtk_table_set_row_spacings (GTK_TABLE (table), 5);
  gtk_table_set_col_spacings (GTK_TABLE (table), 5);

  for (row = 0; row < HELIX_SLOT_LAST; row++)
    {
      GtkWidget *label, *scale;

      label = gtk_label_new (helix_names[row]);
      gtk_misc_set_alignment (GTK_MISC (label), 1.0, 0.5);
      gtk_table_attach (GTK_TABLE (table),
                        label, 0, 1, row, row + 1,
                        GTK_FILL | GTK_SHRINK,
                        GTK_FILL | GTK_SHRINK,
                        0, 0);

      scale = gtk_hscale_new (hwin->adjustments[row]);
      gtk_scale_set_digits (GTK_SCALE (scale), 3);
      gtk_scale_set_value_pos (GTK_SCALE (scale), GTK_POS_RIGHT);
      gtk_table_attach_defaults (GTK_TABLE (table),
                                 scale, 1, 2, row, row + 1);
    }

  gtk_widget_show_all (win);

  return win;
}
