
#ifndef __MIDI_ADJUSTMENT_H__
#define __MIDI_ADJUSTMENT_H__

#include <gtk/gtk.h>
#include <glib.h>

#include "midi-source.h"

#define MIDI_TYPE_ADJUSTMENT            (midi_adjustment_get_type ())
#define MIDI_ADJUSTMENT(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), MIDI_TYPE_ADJUSTMENT, MidiAdjustment))
#define MIDI_ADJUSTMENT_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), MIDI_TYPE_ADJUSTMENT, MidiAdjustmentClass))
#define MIDI_IS_ADJUSTMENT(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MIDI_TYPE_ADJUSTMENT))
#define MIDI_ADJUSTMENTLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MIDI_TYPE_ADJUSTMENT))
#define MIDI_ADJUSTMENT_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), MIDI_TYPE_ADJUSTMENT, MidiAdjustmentClass))


typedef struct _MidiAdjustmentClass MidiAdjustmentClass;
typedef struct _MidiAdjustment      MidiAdjustment;

struct _MidiAdjustment
{
  GtkAdjustment   parent_instance;

  MidiSource     *midi_source;
  gint            controller;
  gint            midi_handler;

  gdouble         target_value;
  guint           update_frequency;
  gint            update_handler;
  gdouble         speed;
};

struct _MidiAdjustmentClass
{
  GtkAdjustmentClass  parent_class;
};


GType    midi_adjustment_get_type  (void) G_GNUC_CONST;

#endif  /* __MIDI_ADJUSTMENT_H__ */
